# Pica Etherpad

Ce dossier contient une image d'Etherpad Lite maintenue par l'association.

Tous les fichiers présents ici suffisent à lancer correctement les deux conteneurs (application et base de données), si un Traefik tourne sur la machine cible.

<!-- TOC depthFrom:2 depthTo:6 withLinks:1 updateOnSave:1 orderedList:0 -->

- [Configuration](#configuration)
- [Ajouter ou modifier un paramètre](#ajouter-ou-modifier-un-paramtre)
- [Mise à jour de l'image](#mise-jour-de-limage)
- [Ajout d'un plugin](#ajout-dun-plugin)

<!-- /TOC -->

## Configuration

Etherpad se configure au lancement du conteneur avec des variables d'environnement. Elles sont présentes à trois endroits :

* Le fichier `etherpad-app.secrets.example` contient les variables privées, par exemple le mot de passe de l'administrateur Etherpad, les identifiants de base de données... Copiez le fichier en enlevant `.example` et remplacez les valeurs. Ce fichier est importé depuis `docker-compose.yml`.
* Le fichier `etherpad-db.secrets.example` contient les variables nécéssaires pour créer un utilisateur de la base de données. Les identifiants doivent correspondre à ceux du fichier `etherpad-app.secrets`.
* Le reste des variables d'environnement non-confidentielles est affecté directement dans le fichier `docker-compose.yml`, via la directive `environment`.

Pour information, les variables que l'on peut affecter directement dans le `docker-compose.yml` sont :

* `ETHERPAD_MINIFY` : booléen, `true` conseillé
* `ETHERPAD_THEME` : `no-skin` ou `colibris`, ce dernier conseillé
* `ETHERPAD_TITLE` : titre de l'instance
* `ETHERPAD_LOGLEVEL` : `INFO`, `DEBUG`, `WARN` ou `ERROR`

## Ajouter ou modifier un paramètre

Pour un paramètre fixé, on modifiera directement `settings.json` et on poussera la modification sur ce dépôt.
Pour un paramètre sujet aux changements, on utilisera une variable d'environnement que l'on documentera ci-dessus et que l'on affectera dans `settings.json` avec la syntaxe `"${NOUVELLE_VARIABLE:Valeur par défaut}"`. Voir le fichier pour des examples.

## Mise à jour de l'image

Pour mettre à jour la version d'Etherpad, il faut simplement modifir la variable `ETHERPAD_VERSION_BUILD` du Dockerfile et le nom dans l'image dans Docker Compose.

L'image est construite automatiquement grâce à la CI.

## Ajout d'un plugin

Etherpad maintient une [liste officielle des plugins](https://static.etherpad.org/plugins.html).

Pour installer un plugin, on évitera de passer par l'interface administrateur et on préfèrera modifier le [Dockerfile](Dockerfile) directement.

Il suffit pour ce faire d'ajouter le nom du package npm dans le `Dockerfile`, sur la ligne `ARG ETHERPAD_PLUGINS`, en respectant l'ordre alphabétique pour la facilité de lecture.
